         .title        "Camerica Reader Plugin (Quattro)"

;06/20/00 
;Written by KH
;Version 1.0

;01/22/06 
;Written by BootGod, pretty much complete rewrite of KH plugin,
;which didn't seem to work

             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
wr_ppu:      .equ 020ch

read_addr:   .equ 00e0h
read_addr_lo:.equ 00e0h
read_addr_hi:.equ 00e1h
cur_bank:    .equ 00e2h
cur_game:    .equ 00e3h

;plugin header defines
p_ver: = 2	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Camerica Quattro carts"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 256 >> 4,0 >> 4
             .db 0 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here
             
;check mirroring             

             ldx #00h
             
             lda #020h
             jsr wr_ppu
             lda #055h
             sta 2007h
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #055h
             bne horz_mir
             lda 2007h
             cmp #0aah
             bne horz_mir
             lda #020h
             jsr wr_ppu
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #0aah
             bne horz_mir
             inx

horz_mir:    txa
             jsr send_byte	;send mirroring
             
prg_hdr:     lda #0		;all Quattro games are 256K
             jsr send_byte
             lda #4
             jsr send_byte
             lda #1
             jsr send_byte

             lda #0
             sta cur_bank
             sta cur_game


nextbank:    lda #0		;reset read address to $8000
             sta read_addr_lo
             tay
             lda #080h
             sta read_addr_hi
             lda cur_game
             jsr set_game
             sta 08000h		;write game select
             ora cur_bank
             sta 0c000h		;write bank select

             jsr send_bank	;send 16K bank

             inc cur_bank
             lda cur_bank
             cmp #4
             bne nextbank
             lda #0
             sta cur_bank
             inc cur_game
             lda cur_game
             cmp #4
             bne nextbank

done:        lda #00h		;signal client no more is coming
             jsr send_byte
             lda #00h
             jsr send_byte
             lda #00h
             jsr send_byte

             rts


set_game:    asl a		;sets the game select
             asl a
             asl a

             rts

send_bank:   lda (read_addr),y	;sends 16K bank from $8000-$BFFF
             jsr send_byte
             iny
             bne send_bank
             jsr baton
             inc read_addr_hi
             lda #0c0h
             cmp read_addr_hi
             bne send_bank
             rts
             


             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end

